#include <windows.h>
#include <process.h>

#include "myunintdef.h"
#include "PowerWildCard.h"
#include "LockSingler.h"
#include "StrIdxArray.h"

void * (* sszrefnewfunc)(intptr_t);
void (* sszrefdeletefunc)(void *);

#include "../../arrayandref.h"

typedef void * (* SSZCALLBACK)(void *, intptr_t, void *, intptr_t, intptr_t);


void SanshouWatashiHenkan(intptr_t & ip, int8_t * const stack)
{
	if(ip < 0){
		ip &= INTPTR_MAX;
	}else{
		ip = (intptr_t)(stack + ip);
	}
}


//////////////////////////////////////////////////////////////////////////
//	function prototype define
#define TUserFunc(FUNC) extern "C" __declspec( dllexport ) intptr_t FUNC(void *argend, int8_t *stack,\
	SSZCALLBACK callback, void *handle, void * (* srn)(intptr_t), void (* srd)(void *))
//////////////////////////////////////////////////////////////////////////


StrIdxArray<SIARFileItem> _in;
StrIdxArray<SIAWFileItem> _out;

void pathset(PWCArray<wchar_t> & str, const Reference * const p)
{
	int i;
	wchar_t * pwc;
	str.Clear();
	str.AddTail((wchar_t *)p->atpos(), p->len()/sizeof(wchar_t));
	str += L'\0';
	pwc = _wfullpath(NULL, str.GetConst(), 0);
	if(pwc == NULL) return;
	str = pwc;
	for(i = 0; i < str.GetLength(); i++) str.GetData()[i] = tolower(str.GetData()[i]);
	str += L'\0';
}

BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
	switch(fdwReason)
	{
	case DLL_PROCESS_ATTACH:
		break;

	case DLL_PROCESS_DETACH:
		_in.Clear();
		_out.Clear();
		break;

	case DLL_THREAD_ATTACH:
		break;

	case DLL_THREAD_DETACH:
		break;
	}
	return TRUE;
}

TUserFunc(Clear)
{
	_in.Clear();
	_out.Clear();
	return 0;
}

TUserFunc(RClose)
{
	Reference * p;
	PWCArray<wchar_t> str;
	p = (Reference *)argend - 1;
	pathset(str, p);
	_in.Delete(str.GetConst());
	return sizeof(Reference);
}

TUserFunc(WClose)
{
	Reference * p;
	PWCArray<wchar_t> str;
	p = (Reference *)argend - 1;
	pathset(str, p);
	_out.Delete(str.GetConst());
	return sizeof(Reference);
}

TUserFunc(RGetSize)
{
	Reference * p;
	PWCArray<wchar_t> str;
	DWORD h;
	p = (Reference *)argend - 1;
	pathset(str, p);
	*(int64_t *)p = (int64_t)_in[str.GetConst()].GetSize(h);
	*(int64_t *)p += (int64_t)h << 32;
	return sizeof(Reference)-sizeof(int64_t);
}

TUserFunc(WGetSize)
{
	Reference * p;
	PWCArray<wchar_t> str;
	DWORD h;
	p = (Reference *)argend - 1;
	pathset(str, p);
	*(int64_t *)p = (int64_t)_out[str.GetConst()].GetSize(h);
	*(int64_t *)p += (int64_t)h << 32;
	return sizeof(Reference)-sizeof(int64_t);
}

TUserFunc(ZRead)
{
	Reference * p;
	PWCArray<wchar_t> str;
	intptr_t ip;
	DWORD l;
	p = (Reference *)( (int8_t *)argend - (sizeof(Reference)+sizeof(intptr_t)*2) );
	pathset(str, p);
	ip = *((intptr_t *)argend-2);
	SanshouWatashiHenkan(ip, stack);
	if(*((intptr_t *)argend-1) < 0){
		*(bool *)p = false;
	}else{
		l = _in[str.GetConst()].ZRead((void *)ip, (DWORD)*((intptr_t *)argend-1));
		*(bool *)p = *((intptr_t *)argend-1) == (intptr_t)l;
	}
	return sizeof(Reference)+sizeof(intptr_t)*2-sizeof(bool);
}

TUserFunc(ZWrite)
{
	Reference * p;
	PWCArray<wchar_t> str;
	intptr_t ip;
	DWORD l;
	p = (Reference *)( (int8_t *)argend - (sizeof(Reference)+sizeof(intptr_t)*2) );
	pathset(str, p);
	ip = *((intptr_t *)argend-2);
	SanshouWatashiHenkan(ip, stack);
	if(*((intptr_t *)argend-1) < 0){
		*(bool *)p = false;
	}else{
		l = _out[str.GetConst()].ZWrite((void *)ip, (DWORD)*((intptr_t *)argend-1));
		*(bool *)p = *((intptr_t *)argend-1) == (intptr_t)l;
	}
	return sizeof(Reference)+sizeof(intptr_t)*2-sizeof(bool);
}

TUserFunc(Read)
{
	Reference * p;
	PWCArray<wchar_t> str;
	intptr_t ip;
	DWORD l;
	p = (Reference *)( (int8_t *)argend - (sizeof(Reference)+sizeof(intptr_t)*2) );
	pathset(str, p);
	ip = *((intptr_t *)argend-2);
	SanshouWatashiHenkan(ip, stack);
	if(*((intptr_t *)argend-1) < 0){
		*(bool *)p = false;
	}else{
		l = _in[str.GetConst()].Read((void *)ip, (DWORD)*((intptr_t *)argend-1));
		*(bool *)p = *((intptr_t *)argend-1) == (intptr_t)l;
	}
	return sizeof(Reference)+sizeof(intptr_t)*2-sizeof(bool);
}

TUserFunc(Write)
{
	Reference * p;
	PWCArray<wchar_t> str;
	intptr_t ip;
	DWORD l;
	p = (Reference *)( (int8_t *)argend - (sizeof(Reference)+sizeof(intptr_t)*2) );
	pathset(str, p);
	ip = *((intptr_t *)argend-2);
	SanshouWatashiHenkan(ip, stack);
	if(*((intptr_t *)argend-1) < 0){
		*(bool *)p = false;
	}else{
		l = _out[str.GetConst()].Write((void *)ip, (DWORD)*((intptr_t *)argend-1));
		*(bool *)p = *((intptr_t *)argend-1) == (intptr_t)l;
	}
	return sizeof(Reference)+sizeof(intptr_t)*2-sizeof(bool);
}
