#define __TOOL_MODE__
#include "Luna.h"

extern int stricmp(const  char *string1, const  char *string2)
{
	return _stricmp(string1, string2);
}



#include "myunintdef.h"
#include "PowerWildCard.h"

void * (* sszrefnewfunc)(intptr_t);
void (* sszrefdeletefunc)(void *);

#include "../../arrayandref.h"

typedef void * (* SSZCALLBACK)(void *, intptr_t, void *, intptr_t, intptr_t);


void SanshouWatashiHenkan(intptr_t & ip, int8_t * const stack)
{
	if(ip < 0){
		ip &= INTPTR_MAX;
	}else{
		ip = (intptr_t)(stack + ip);
	}
}

void reftocstr(PWCArray<char> & cstr, const Reference & strref)
{
	cstr.Clear();
	cstr.SetLength(
		WideCharToMultiByte(CP_THREAD_ACP, 0,
			(wchar_t *)strref.atpos(), strref.len()/sizeof(wchar_t),
			NULL, 0, NULL, NULL));
	WideCharToMultiByte(CP_THREAD_ACP, 0,
		(wchar_t *)strref.atpos(), strref.len()/sizeof(wchar_t),
		cstr.GetData(), cstr.GetLength(), NULL, NULL);
	cstr += '\0';
}

//////////////////////////////////////////////////////////////////////////
//	function prototype define
#define TUserFunc(FUNC) extern "C" __declspec( dllexport ) intptr_t FUNC(void *argend, int8_t *stack,\
	SSZCALLBACK callback, void *handle, void * (* srn)(intptr_t), void (* srd)(void *))
//////////////////////////////////////////////////////////////////////////


uint32_t _flags;
int _heig, _widt;


LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch(iMsg){
	case WM_CREATE:
		if(!Luna::InitToolMode(hwnd, _flags)){
			PostMessage(hwnd, WM_CLOSE, 0, 0);
		}else{
			Luna::SetFrameRate(60);
			LunaMath::RandSeed(time(NULL));
			if(!Luna::StartToolMode(_widt, _heig)) PostMessage(hwnd, WM_CLOSE, 0, 0);
		}
		return 0;
	case WM_SYSCOMMAND:
		// XN[Z[o[֌W̏}
		if(wParam == SC_SCREENSAVE || wParam == SC_MONITORPOWER) return 0;
		break;
	case WM_KEYDOWN:
		switch(wParam){
		case VK_ESCAPE:
			PostMessage(hwnd, WM_CLOSE, 0, 0);
			return 0;
		}
		break;
	case WM_SYSKEYDOWN:
		switch(wParam){
		case VK_F4:
			PostMessage(hwnd, WM_CLOSE, 0, 0);
			return 0;
		}
		break;
	case WM_CHAR:
		LunaFEP::AddChara((uint32_t)wParam);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return (Luna::MsgToolMode(hwnd, iMsg, wParam, lParam) == 1 ? 0 : DefWindowProc(hwnd,iMsg,wParam,lParam));
}




TUserFunc(Init)
{
	PWCArray<wchar_t> str;
	Reference * caption;
	int32_t x, y, w, h;
	HWND hwnd;
	WNDCLASS wndclass;
	caption = (Reference *)( (int8_t *)argend - (sizeof(Reference)+sizeof(int32_t)*3) );
	str.AddTail((wchar_t *)caption->atpos(), caption->len()/sizeof(wchar_t));
	str += L'\0';
	wndclass.style         = CS_DBLCLKS;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = GetModuleHandle(NULL);
	wndclass.hIcon         = LoadIcon(GetModuleHandle(NULL), _T("SSZIcon"));
	wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = str.GetConst();
	RegisterClass(&wndclass);
	_flags = *((int32_t *)argend-3);
	w = _widt = *((int32_t *)argend-2);
	w += GetSystemMetrics(SM_CXBORDER) + GetSystemMetrics(SM_CXEDGE) + GetSystemMetrics(SM_CXDLGFRAME);
	h = _heig = *((int32_t *)argend-1);
	h += GetSystemMetrics(SM_CYBORDER) + GetSystemMetrics(SM_CYEDGE) + GetSystemMetrics(SM_CYDLGFRAME) + GetSystemMetrics(SM_CYCAPTION);
	x = GetSystemMetrics(SM_CXSCREEN)/2 - w/2;
	y = GetSystemMetrics(SM_CYSCREEN)/2 - h/2;
	hwnd = CreateWindowEx(0, str.GetConst(), str.GetConst(),
		WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX, x, y, w, h, NULL, NULL, GetModuleHandle(NULL), NULL);
	UpdateWindow(hwnd);
	ShowWindow(hwnd, SW_SHOW);
	*(bool *)( (int8_t *)argend - (sizeof(Reference)+sizeof(int32_t)*3) ) = hwnd != NULL;
	return sizeof(Reference)+sizeof(int32_t)*3-sizeof(bool);
}

TUserFunc(End)
{
	Luna::UninitToolMode();
	return 0;
}

TUserFunc(WaitMsg)
{
	const intptr_t hikihikuretsize = 0-sizeof(bool);
	const int TIMER_SCALE_SHIFT = 32;
	static uint64_t OldTime = 0;
	MSG  msg;
	bool * ret = (bool *)argend;
	while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
		if(msg.message == WM_QUIT){
			*ret = false;
			return hikihikuretsize;
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	uint64_t WaitTime = Luna::GetSystemTimeSecondCount() / 60;
	uint64_t NowTime = (uint64_t)timeGetTime() << TIMER_SCALE_SHIFT;
	uint64_t DifferenceTime = NowTime - OldTime;
	if(DifferenceTime < WaitTime){
		uint32_t SleepTime = (uint32_t)((WaitTime - DifferenceTime) >> TIMER_SCALE_SHIFT);
		Sleep(SleepTime);
		OldTime += WaitTime;
	}else{
		OldTime = NowTime;
	}
	Luna::WaitForMsgLoop();
	*ret = true;
	return hikihikuretsize;
}




TUserFunc(Refresh)
{
	Luna3D::Refresh();
	return 0;
}

TUserFunc(Clear)
{
	Luna3D::Clear(D3DCLEAR_TARGET, *((uint32_t *)argend-1));
	return sizeof(uint32_t);
}

TUserFunc(ColorFill)
{
	RECT * p;
	p = (RECT *)( (int8_t *)argend - (sizeof(RECT)+sizeof(uint32_t)) );
	p->right = p->left + p->right;
	p->bottom = p->top + p->bottom;
	Luna3D::ColorFill(p, *((uint32_t *)argend-1));
	return sizeof(RECT)+sizeof(uint32_t);
}

TUserFunc(BeginScene)
{
	*(bool *)argend = Luna3D::BeginScene();
	return 0-sizeof(bool);
}

TUserFunc(EndScene)
{
	Luna3D::EndScene();
	return 0;
}

TUserFunc(SetBlendingType)
{
	Luna3D::SetBlendingType((eBlendType)*((int32_t *)argend-1));
	return sizeof(int32_t);
}

TUserFunc(SetPerspective)
{
	Luna3D::SetPerspective(*(bool *)( (int8_t *)argend - (sizeof(bool)+sizeof(float)*3) ),
		*((float *)argend-3), *((float *)argend-2), *((float *)argend-1));
	return sizeof(bool)+sizeof(float)*3;
}

TUserFunc(SetScissoring)
{
	((RECT *)argend-1)->right = ((RECT *)argend-1)->left + ((RECT *)argend-1)->right;
	((RECT *)argend-1)->bottom = ((RECT *)argend-1)->top + ((RECT *)argend-1)->bottom;
	Luna3D::SetScissoring(*(bool *)( (int8_t *)argend - (sizeof(bool)+sizeof(RECT)) ), (RECT *)argend-1);
	return sizeof(bool)+sizeof(RECT);
}

TUserFunc(SetOffsetUV)
{
	LunaTexture::SetOffsetUV(*((float *)argend-1));
	return sizeof(float);
}

TUserFunc(FontBegin)
{
	PWCArray<char> tmp;
	Reference * fname;
	fname = (Reference *)( (int8_t *)argend - (sizeof(Reference)+sizeof(int32_t)) );
	reftocstr(tmp, *fname);
	Luna3D::FontBegin(tmp.GetConst(), *((int32_t *)argend-1));
	return sizeof(Reference)+sizeof(int32_t);
}

TUserFunc(FontDraw)
{
	PWCArray<char> tmp;
	Reference * str;
	str = (Reference *)argend - 1;
	reftocstr(tmp, *str);
	Luna3D::FontDraw(*(int32_t *)( (int8_t *)argend - (sizeof(int32_t)*2+sizeof(uint32_t)*2+sizeof(Reference)) ),
		*(int32_t *)( (int8_t *)argend - (sizeof(int32_t)+sizeof(uint32_t)*2+sizeof(Reference)) ),
		*(uint32_t *)( (int8_t *)argend - (sizeof(uint32_t)*2+sizeof(Reference)) ),
		*(uint32_t *)( (int8_t *)argend - (sizeof(uint32_t)+sizeof(Reference)) ), tmp.GetConst());
	return sizeof(int32_t)*2+sizeof(uint32_t)*2+sizeof(Reference);
}

TUserFunc(FontEnd)
{
	Luna3D::FontEnd();
	return 0;
}

TUserFunc(GetKeyData)
{
	*(bool *)((int32_t *)argend-1) = LunaInput::GetKeyData(*((int32_t *)argend-1));
	return sizeof(int32_t)-sizeof(bool);
}

TUserFunc(KeyBufferLoop)
{
	bool b;
	unsigned long Key = 0;
	intptr_t ip;
	b = LunaInput::KeyBufferLoop(&Key);
	ip = *((intptr_t *)argend-1);
	SanshouWatashiHenkan(ip, stack);
	*(int32_t *)ip = Key;
	*(bool *)((intptr_t *)argend-1) = b;
	return sizeof(intptr_t)-sizeof(bool);
}




TUserFunc(SurfaceCopyToBG)
{
	Luna3D::CopyToRenderTarget(NULL, (LSURFACE)*((intptr_t *)argend-1), NULL);
	return sizeof(intptr_t);
}

TUserFunc(SurfaceLoad)
{
	intptr_t ip;
	Reference * file;
	PWCArray<char> tmp;
	ip = *(intptr_t *)( (int8_t *)argend - (sizeof(intptr_t)+sizeof(Reference)) );
	SanshouWatashiHenkan(ip, stack);
	file = (Reference *)argend - 1;
	reftocstr(tmp, *file);
	*(intptr_t *)ip = (intptr_t)LunaSurface::CreateFromFile(tmp.GetConst(), FORMAT_BACKBUFFER);
	return sizeof(intptr_t)+sizeof(Reference);
}

TUserFunc(SurfaceRelease)
{
	LunaSurface::Release((LSURFACE)*((intptr_t *)argend-1));
	return sizeof(intptr_t);
}




TUserFunc(TextureLoad)
{
	intptr_t ip;
	Reference * file;
	PWCArray<char> tmp;
	ip = *(intptr_t *)( (int8_t *)argend - (sizeof(intptr_t)+sizeof(Reference)) );
	SanshouWatashiHenkan(ip, stack);
	file = (Reference *)argend - 1;
	reftocstr(tmp, *file);
	*(intptr_t *)ip = (intptr_t)LunaTexture::CreateFromFile(tmp.GetConst(), FORMAT_TEXTURE_3D);
	return sizeof(intptr_t)+sizeof(Reference);
}

TUserFunc(TextureDraw)
{
	LunaTexture::Draw((LTEXTURE)*(intptr_t *)( (int8_t *)argend - (sizeof(intptr_t)+sizeof(LUNARECT)*2) ),
		(LUNARECT *)argend-2, (LUNARECT *)argend-1, COLOR_BASE);
	return sizeof(intptr_t)+sizeof(LUNARECT)*2;
}

TUserFunc(TextureDrawRotate)
{
	LunaTexture::DrawRotate(
		(LTEXTURE)*(intptr_t *)( (int8_t *)argend - (sizeof(intptr_t)+sizeof(LUNARECT)*2+sizeof(uint32_t)) ),
		(LUNARECT *)( (int8_t *)argend - (sizeof(LUNARECT)*2+sizeof(uint32_t)) ),
		(LUNARECT *)( (int8_t *)argend - (sizeof(LUNARECT)+sizeof(uint32_t)) ),
		COLOR_BASE, *((uint32_t *)argend-1));
	return sizeof(intptr_t)+sizeof(LUNARECT)*2+sizeof(uint32_t);
}

TUserFunc(TextureRelease)
{
	LunaTexture::Release((LTEXTURE)*((intptr_t *)argend-1));
	return sizeof(intptr_t);
}




TUserFunc(SpriteCreate)
{
	intptr_t ip;
	ip = *(intptr_t *)( (int8_t *)argend - (sizeof(intptr_t)+sizeof(uint32_t)) );
	SanshouWatashiHenkan(ip, stack);
	*(intptr_t *)ip = (intptr_t)LunaSprite::Create(*((uint32_t *)argend-1), PRIM_VERTEX_UV1, true);
	return sizeof(intptr_t)+sizeof(uint32_t);
}

TUserFunc(SpriteAttatchTexture)
{
	LunaSprite::AttatchTexture((LSPRITE)*((intptr_t *)argend-2), 0, (LTEXTURE)*((intptr_t *)argend-1));
	return sizeof(intptr_t)*2;
}

TUserFunc(SpriteRendering)
{
	LunaSprite::Rendering((LSPRITE)*((intptr_t *)argend-1));
	return sizeof(intptr_t);
}

TUserFunc(SpriteResetBuffer)
{
	LunaSprite::ResetBuffer((LSPRITE)*((intptr_t *)argend-1));
	return sizeof(intptr_t);
}

TUserFunc(SpriteUpdateBuffer)
{
	LunaSprite::UpdateBuffer((LSPRITE)*((intptr_t *)argend-1));
	return sizeof(intptr_t);
}

TUserFunc(SpriteDrawSquare)
{
	LunaSprite::DrawSquare(
		(LSPRITE)*(intptr_t *)( (int8_t *)argend - (sizeof(intptr_t)+sizeof(LUNARECT)+sizeof(float)+sizeof(LUNARECT)) ),
		(LUNARECT *)( (int8_t *)argend - (sizeof(LUNARECT)+sizeof(float)+sizeof(LUNARECT)) ),
		*(float *)( (int8_t *)argend - (sizeof(float)+sizeof(LUNARECT)) ),
		(LUNARECT *)argend-1, COLOR_BASE);
	return sizeof(intptr_t)+sizeof(LUNARECT)+sizeof(float)+sizeof(LUNARECT);
}

TUserFunc(SpriteDrawList)
{
	LunaSprite::DrawList(
		(LSPRITE)*(intptr_t *)( (int8_t *)argend - (sizeof(intptr_t)+sizeof(Reference)*6+sizeof(int32_t)+sizeof(LUNARECT)) ),
		(float *)((Reference *)( (int8_t *)argend - (sizeof(Reference)*6+sizeof(int32_t)+sizeof(LUNARECT)) ))->atpos(),
		(float *)((Reference *)( (int8_t *)argend - (sizeof(Reference)*5+sizeof(int32_t)+sizeof(LUNARECT)) ))->atpos(),
		(float *)((Reference *)( (int8_t *)argend - (sizeof(Reference)*4+sizeof(int32_t)+sizeof(LUNARECT)) ))->atpos(),
		(float *)((Reference *)( (int8_t *)argend - (sizeof(Reference)*3+sizeof(int32_t)+sizeof(LUNARECT)) ))->atpos(),
		(Sint32 *)((Reference *)( (int8_t *)argend - (sizeof(Reference)*2+sizeof(int32_t)+sizeof(LUNARECT)) ))->atpos(),
		(D3DCOLOR *)((Reference *)( (int8_t *)argend - (sizeof(Reference)*1+sizeof(int32_t)+sizeof(LUNARECT)) ))->atpos(),
		*(int32_t *)( (int8_t *)argend - (sizeof(int32_t)+sizeof(LUNARECT)) ), (LUNARECT *)argend-1);
	return sizeof(intptr_t)+sizeof(Reference)*6+sizeof(int32_t)+sizeof(LUNARECT);
}

TUserFunc(SpriteRelease)
{
	LunaSprite::Release((LSPRITE)*((intptr_t *)argend-1));
	return sizeof(intptr_t);
}




TUserFunc(MathRandSeed)
{
	LunaMath::RandSeed(*((uint32_t *)argend-1));
	return sizeof(uint32_t);
}

TUserFunc(MathRand)
{
	*((int32_t *)argend-2) = LunaMath::Rand(*((int32_t *)argend-2), *((int32_t *)argend-1));
	return sizeof(int32_t)*2-sizeof(int32_t);
}

TUserFunc(MathRandF)
{
	*((float *)argend-2) = LunaMath::RandF(*((float *)argend-2), *((float *)argend-1));
	return sizeof(float)*2-sizeof(float);
}

TUserFunc(MathCos)
{
	*(float *)((int32_t *)argend-1) = LunaMath::Cos(*((int32_t *)argend-1));
	return sizeof(int32_t)-sizeof(float);
}

TUserFunc(MathSin)
{
	*(float *)((int32_t *)argend-1) = LunaMath::Sin(*((int32_t *)argend-1));
	return sizeof(int32_t)-sizeof(float);
}

TUserFunc(MathAtan)
{
	*((int32_t *)argend-2) = LunaMath::Atan(*((Sint32 *)argend-2), *((Sint32 *)argend-1));
	return sizeof(int32_t)*2-sizeof(int32_t);
}
