enum TokenKind
{
	NULL_TOKEN = 0,
///////////////////////////////////////////////////////////////////////////////
	POINT_TOKEN,
	COLOCOLO_TOKEN,
	DIA_TOKEN, COLOYAJIRUSHI_TOKEN,
	EXCLAMATION_TOKEN, PLSPLS_TOKEN, MNSMNS_TOKEN,
	SHOUKAKKOOPEN_TOKEN, SHOUKAKKOCLOSE_TOKEN,
	CHUUKAKKOOPEN_TOKEN, CHUUKAKKOCLOSE_TOKEN,
	DAIKAKKOOPEN_TOKEN, DAIKAKKOCLOSE_TOKEN,
	BRACOLOOPEN_TOKEN, BRACOLOCLOSE_TOKEN,
	KAKKOCOLOOPEN_TOKEN, KAKKOCOLOCLOSE_TOKEN,
	SQUOT_TOKEN,
	DQUOT_TOKEN,
	BACKSLA_TOKEN,
	COLON_TOKEN,
	SEMICOLON_TOKEN,
///////////////////////////////////////////////////////////////////////////////
	KAKERU_TOKEN, WARU_TOKEN, AMARI_TOKEN,
	PULUS_TOKEN, MINUS_TOKEN,
	LSHIFT_TOKEN, RSHIFT_TOKEN,
	SHOU_TOKEN, SHOUOREQUAL_TOKEN, DAI_TOKEN, DAIOREQUAL_TOKEN,
	EQUAL_TOKEN, NOTEQUAL_TOKEN,
	AND_TOKEN,
	XOR_TOKEN,
	OR_TOKEN,
	ANDAND_TOKEN,
	OROR_TOKEN,
	QUESTION_TOKEN,
	DAINYUU_TOKEN, PULUSDAINYUU_TOKEN, MINUSDAINYUU_TOKEN, KAKERUDAINYUU_TOKEN, WARUDAINYUU_TOKEN, AMARIDAINYUU_TOKEN,
	ANDDAINYUU_TOKEN, XORDAINYUU_TOKEN, ORDAINYUU_TOKEN, LSHIFTDAINYUU_TOKEN, RSHIFTDAINYUU_TOKEN,
	TENDAINYUU_TOKEN,
	YAJIRUSHI_TOKEN, SHIROYAJIRUSHI_TOKEN,
	SHARP_TOKEN,
	TENTEN_TOKEN, COMMA_TOKEN,
///////////////////////////////////////////////////////////////////////////////
	OTHERKIND_TOKEN,
	BOOL_TOKEN, BRANCH_TOKEN, BREAK_TOKEN, BYTE_TOKEN,
	CASE_TOKEN, CHAR_TOKEN, CLASS_TOKEN, COMM_TOKEN, COND_TOKEN, CONST_TOKEN, CONTINUE_TOKEN, CORE_TOKEN,
	DEFAULT_TOKEN, DELETE_TOKEN, DIFF_TOKEN, DO_TOKEN, DOUBLE_TOKEN,
	ELSE_TOKEN, ENUM_TOKEN,
	FALSE_TOKEN, FLOAT_TOKEN, FUNC_TOKEN,
	GBL_TOKEN,
	IF_TOKEN, INDEX_TOKEN, INT_TOKEN,
	LEN_TOKEN, LIB_TOKEN, LIST_TOKEN, LOCK_TOKEN, LONG_TOKEN, LOOP_TOKEN,
	MBR_TOKEN, METHOD_TOKEN,
	NEW_TOKEN,
	PLUGIN_TOKEN, PROPERTY_TOKEN, PUBLIC_TOKEN,
	REF_TOKEN, RETURN_TOKEN,
	SELF_TOKEN, SHORT_TOKEN, SIZEOF_TOKEN, SWITCH_TOKEN,
	THREAD_TOKEN, TRUE_TOKEN, TYPE_TOKEN, TYPEIDOF_TOKEN,
	UBYTE_TOKEN, UINT_TOKEN, ULONG_TOKEN, USHORT_TOKEN,
	VOID_TOKEN,
	WAIT_TOKEN, WHILE_TOKEN
};

inline bool IsSoushokuToken(const TokenKind t)
{
	return t == PUBLIC_TOKEN || t == CONST_TOKEN || t == PROPERTY_TOKEN || t == CORE_TOKEN;
}

inline bool IsPublicToken(const TokenKind t)
{
	return t == PUBLIC_TOKEN || t == CONST_TOKEN || t == PROPERTY_TOKEN;
}

inline bool IsReadOnlyToken(const TokenKind t)
{
	return t == CONST_TOKEN || t == PROPERTY_TOKEN;
}

inline bool IsKoukaiHensuuToken(const TokenKind t)
{
	return t == PUBLIC_TOKEN || t == PROPERTY_TOKEN;
}

int32_t TokenTtoTypeId(const intptr_t * const iap, int & i)
{
	if(IsSoushokuToken((TokenKind)iap[i])) i++;
	switch(iap[i++]){
	case BYTE_TOKEN:
		return BYTE_TYPEID;
	case SHORT_TOKEN:
		return SHORT_TYPEID;
	case INT_TOKEN:
		return INT_TYPEID;
	case LONG_TOKEN:
		return LONG_TYPEID;
	case UBYTE_TOKEN:
		return UBYTE_TYPEID;
	case USHORT_TOKEN:
		return USHORT_TYPEID;
	case UINT_TOKEN:
		return UINT_TYPEID;
	case ULONG_TOKEN:
		return ULONG_TYPEID;
	case INDEX_TOKEN:
		return ADDRESS_TYPEID;
	case FLOAT_TOKEN:
		return FLOAT_TYPEID;
	case DOUBLE_TOKEN:
		return DOUBLE_TYPEID;
	case CHAR_TOKEN:
		return CHAR_TYPEID;
	case BOOL_TOKEN:
		return BOOL_TYPEID;
	case VOID_TOKEN:
		return VOID_TYPEID;
	case REF_TOKEN:
		return REF_TYPEID;
	case LIST_TOKEN:
		return LIST_TYPEID;
	case FUNC_TOKEN:
		return FUNC_TYPEID;
	case METHOD_TOKEN:
		return METHOD_TYPEID;
	case THREAD_TOKEN:
		return ~(int32_t)iap[i++];
	case CLASS_TOKEN:
	case ENUM_TOKEN:
		return (int32_t)iap[i++];
	}
	return UNKNOWN_TYPEID;
}
