typedef void * (* SSZCALLBACK)(void *, intptr_t, void *, intptr_t, intptr_t);
typedef intptr_t (* PLUGINFUNC)(void *, int8_t *, SSZCALLBACK, void *, void * (*)(intptr_t), void (*)(void *));

struct KasouKikai
{
	template<typename TYPE> class StackArray : public PWCArray<TYPE>
	{
	public:
		TYPE * Pop(const intptr_t len)
		{
			return Data + (Length-=len);
		}
	};
	struct CallBackStruct
	{
		KasouKikai * pvm;
		const PWCArray<uint8_t> * pbcode;
		PWCArray<int8_t> * pgres;
	};
	struct ThreadStruct
	{
		CallBackStruct cbs;
		intptr_t calladr;
		intptr_t jigoshori;
		void * phikisuu;
		intptr_t hikisize;
	};
	StackArray<int8_t> stack;
	intptr_t localhensuu;
	StackArray<intptr_t> localstack;
	StackArray<intptr_t> memberstack;
	StackArray<intptr_t> callstack;
	StackArray<intptr_t> gbldellist;
	static void * CallBack(void * pcbs, intptr_t calladr, void * phikisuu, intptr_t hikisize, intptr_t retsize)
	{
		StackArray<intptr_t> tmp;
		KasouKikai * pv;
		intptr_t ip;
		pv = ((CallBackStruct *)pcbs)->pvm;
		pv->stack.AddTail((int8_t *)phikisuu, hikisize);
		if(calladr < 0){
			pv->stack.SetLength(pv->stack.GetLength()+sizeof(int64_t));//߂lp̈mɊm
			pv->stack.Pop(sizeof(int64_t));//߂
			ip = ((PLUGINFUNC)(calladr&INTPTR_MAX))(pv->stack.GetData()+pv->stack.GetLength(), pv->stack.GetData(), CallBack, pcbs, sszrefnewfunc, sszrefdeletefunc);
			pv->stack.Pop(ip);
		}else{
			tmp = pv->callstack;
			pv->callstack.Clear();
			pv->Jikkou(*((CallBackStruct *)pcbs)->pbcode, *((CallBackStruct *)pcbs)->pgres, calladr);
			pv->callstack = tmp;
		}
		return pv->stack.Pop(retsize);
	}
	static unsigned __stdcall ThreadFunc(void * p)
	{
		KasouKikai vm;
		vm.Clear();
		((ThreadStruct *)p)->cbs.pvm = &vm;
		CallBack(&((ThreadStruct *)p)->cbs, ((ThreadStruct *)p)->calladr, ((ThreadStruct *)p)->phikisuu, ((ThreadStruct *)p)->hikisize, 0);
		if(((ThreadStruct *)p)->jigoshori != 0){
			vm.memberstack += ((intptr_t)((ThreadStruct *)p)->phikisuu + ((ThreadStruct *)p)->hikisize) | INTPTR_MIN;
			CallBack(&((ThreadStruct *)p)->cbs, ((ThreadStruct *)p)->jigoshori, NULL, 0, 0);
		}
		delete [] (int8_t *)((ThreadStruct *)p)->phikisuu;
		delete (ThreadStruct *)p;
		return 0;
	}
	void Clear()
	{
		stack.Clear();
		localhensuu = 0;
		localstack.Clear();
		memberstack.Clear();
		callstack.Clear();
	}
	void HensuuAddressHenkan(intptr_t & ip)
	{
		ip = (intptr_t)(stack.GetConst() + localhensuu + ip);
	}
	void MemberAddressHenkan(intptr_t & ip)
	{
		if(memberstack.GetConst()[memberstack.GetLength()-1] <= 0){
			ip = (intptr_t)((int8_t *)(memberstack.GetConst()[memberstack.GetLength()-1]&INTPTR_MAX) + ip);
		}else{
			ip = (intptr_t)(stack.GetConst() + memberstack.GetConst()[memberstack.GetLength()-1] + ip);
		}
	}
	void GlobalAddressHenkan(intptr_t & ip, PWCArray<int8_t> & globalres)
	{
		ip = (intptr_t)(globalres.GetConst() + ip);
	}
	void SanshouAddressHenkan(intptr_t & ip)
	{
		if(ip >= 0){
			ip = (intptr_t)(stack.GetConst() + ip);
		}else{
			ip = ip & INTPTR_MAX;
		}
	}
	template<typename TYPE> void Push(const TYPE x)
	{
		stack.SetLength(stack.GetLength()+sizeof(TYPE));
		*(TYPE *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE)) = x;
	}
	template<typename TYPE> TYPE Pop()
	{
		return *(TYPE *)(stack.Pop(sizeof(TYPE)));
	}
	template<typename TYPE1, typename TYPE2> void Cast()
	{
		Push((TYPE2)Pop<TYPE1>());
	}
	template<typename TYPE> void Minus()
	{
		*(TYPE *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE)) *= -1;
	}
	template<typename TYPE> void Not()
	{
		TYPE * p;
		p = (TYPE *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE));
		*p = ~*p;
	}
	void NotBool()
	{
		bool * bp;
		bp = (bool *)(stack.GetConst()+stack.GetLength()-sizeof(bool));
		*bp = !*bp;
	}
	template<typename TYPE> void Tasu()
	{
		*(TYPE *)(stack.Pop(sizeof(TYPE))-sizeof(TYPE)) += *(TYPE *)(stack.GetConst()+stack.GetLength());
	}
	template<typename TYPE> void Hiku()
	{
		*(TYPE *)(stack.Pop(sizeof(TYPE))-sizeof(TYPE)) -= *(TYPE *)(stack.GetConst()+stack.GetLength());
	}
	template<typename TYPE> void Kakeru()
	{
		*(TYPE *)(stack.Pop(sizeof(TYPE))-sizeof(TYPE)) *= *(TYPE *)(stack.GetConst()+stack.GetLength());
	}
	template<typename TYPE> void Waru()
	{
		*(TYPE *)(stack.Pop(sizeof(TYPE))-sizeof(TYPE)) /= *(TYPE *)(stack.GetConst()+stack.GetLength());
	}
	template<typename TYPE> void Amari()
	{
		*(TYPE *)(stack.Pop(sizeof(TYPE))-sizeof(TYPE)) %= *(TYPE *)(stack.GetConst()+stack.GetLength());
	}
	template<typename TYPE> void And()
	{
		*(TYPE *)(stack.Pop(sizeof(TYPE))-sizeof(TYPE)) &= *(TYPE *)(stack.GetConst()+stack.GetLength());
	}
	void AndBool()
	{
		bool * bp;
		bp = (bool *)(stack.Pop(sizeof(bool))-sizeof(bool));
		*bp = *bp && *(bool *)(stack.GetConst()+stack.GetLength());
	}
	template<typename TYPE> void Xor()
	{
		*(TYPE *)(stack.Pop(sizeof(TYPE))-sizeof(TYPE)) ^= *(TYPE *)(stack.GetConst()+stack.GetLength());
	}
	void XorBool()
	{
		bool * bp;
		bp = (bool *)(stack.Pop(sizeof(bool))-sizeof(bool));
		*bp = *bp != *(bool *)(stack.GetConst()+stack.GetLength());
	}
	template<typename TYPE> void Or()
	{
		*(TYPE *)(stack.Pop(sizeof(TYPE))-sizeof(TYPE)) |= *(TYPE *)(stack.GetConst()+stack.GetLength());
	}
	void OrBool()
	{
		bool * bp;
		bp = (bool *)(stack.Pop(sizeof(bool))-sizeof(bool));
		*bp = *bp || *(bool *)(stack.GetConst()+stack.GetLength());
	}
	template<typename TYPE> void LShift()
	{
		*(TYPE *)(stack.Pop(sizeof(TYPE))-sizeof(TYPE)) <<= *(TYPE *)(stack.GetConst()+stack.GetLength());
	}
	template<typename TYPE> void RShift()
	{
		*(TYPE *)(stack.Pop(sizeof(TYPE))-sizeof(TYPE)) >>= *(TYPE *)(stack.GetConst()+stack.GetLength());
	}
	template<typename TYPE> void Incl()
	{
		intptr_t ip;
		ip = *(intptr_t *)stack.Pop(sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		++*(TYPE *)ip;
	}
	template<typename TYPE> void InclKaraSanshou()
	{
		intptr_t ip;
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		++*(TYPE *)ip;
	}
	template<typename TYPE> void InclKaraAtai()
	{
		intptr_t ip;
		stack.SetLength(stack.GetLength()-sizeof(intptr_t)+sizeof(TYPE));
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE));
		SanshouAddressHenkan(ip);
		*(TYPE *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE)) = ++*(TYPE *)ip;
	}
	template<typename TYPE> void InclKaraMaenoAtai()
	{
		intptr_t ip;
		stack.SetLength(stack.GetLength()-sizeof(intptr_t)+sizeof(TYPE));
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE));
		SanshouAddressHenkan(ip);
		*(TYPE *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE)) = (*(TYPE *)ip)++;
	}
	template<typename TYPE> void Decl()
	{
		intptr_t ip;
		ip = *(intptr_t *)stack.Pop(sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		--*(TYPE *)ip;
	}
	template<typename TYPE> void DeclKaraSanshou()
	{
		intptr_t ip;
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		--*(TYPE *)ip;
	}
	template<typename TYPE> void DeclKaraAtai()
	{
		intptr_t ip;
		stack.SetLength(stack.GetLength()-sizeof(intptr_t)+sizeof(TYPE));
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE));
		SanshouAddressHenkan(ip);
		*(TYPE *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE)) = --*(TYPE *)ip;
	}
	template<typename TYPE> void DeclKaraMaenoAtai()
	{
		intptr_t ip;
		stack.SetLength(stack.GetLength()-sizeof(intptr_t)+sizeof(TYPE));
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE));
		SanshouAddressHenkan(ip);
		*(TYPE *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE)) = (*(TYPE *)ip)--;
	}
	template<typename TYPE> void Dainyuu()
	{
		intptr_t ip;
		ip = *(intptr_t *)stack.Pop(sizeof(intptr_t)+sizeof(TYPE));
		SanshouAddressHenkan(ip);
		*(TYPE *)ip = *(TYPE *)(stack.GetConst()+stack.GetLength()+sizeof(intptr_t));
	}
	template<typename TYPE> void DainyuuKaraSanshou()
	{
		intptr_t ip;
		ip = *(intptr_t *)(stack.Pop(sizeof(TYPE))-sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		*(TYPE *)ip = *(TYPE *)(stack.GetConst()+stack.GetLength());
	}
	template<typename TYPE> void SanshouKaraSanshousaki()
	{
		intptr_t ip;
		stack.SetLength(stack.GetLength()-sizeof(intptr_t)+sizeof(TYPE));
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE));
		SanshouAddressHenkan(ip);
		*(TYPE *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE)) = *(TYPE *)ip;
	}
	template<typename TYPE> void Equal()
	{
		bool b;
		b = *(TYPE *)stack.Pop(sizeof(TYPE)*2) == *(TYPE *)(stack.GetConst()+stack.GetLength()+sizeof(TYPE));
		Push(b);
	}
	void EqualRef()
	{
		bool b;
		b = ((Reference *)stack.Pop(sizeof(Reference)*2))->obj() == ((Reference *)(stack.GetConst()+stack.GetLength()+sizeof(Reference)))->obj();
		Push(b);
	}
	template<typename TYPE> void NotEqual()
	{
		bool b;
		b = *(TYPE *)stack.Pop(sizeof(TYPE)*2) != *(TYPE *)(stack.GetConst()+stack.GetLength()+sizeof(TYPE));
		Push(b);
	}
	void NotEqualRef()
	{
		bool b;
		b = ((Reference *)stack.Pop(sizeof(Reference)*2))->obj() != ((Reference *)(stack.GetConst()+stack.GetLength()+sizeof(Reference)))->obj();
		Push(b);
	}
	template<typename TYPE> void Shou()
	{
		bool b;
		b = *(TYPE *)stack.Pop(sizeof(TYPE)*2) < *(TYPE *)(stack.GetConst()+stack.GetLength()+sizeof(TYPE));
		Push(b);
	}
	template<typename TYPE> void ShouorEqual()
	{
		bool b;
		b = *(TYPE *)stack.Pop(sizeof(TYPE)*2) <= *(TYPE *)(stack.GetConst()+stack.GetLength()+sizeof(TYPE));
		Push(b);
	}
	template<typename TYPE> void Dai()
	{
		bool b;
		b = *(TYPE *)stack.Pop(sizeof(TYPE)*2) > *(TYPE *)(stack.GetConst()+stack.GetLength()+sizeof(TYPE));
		Push(b);
	}
	template<typename TYPE> void DaiorEqual()
	{
		bool b;
		b = *(TYPE *)stack.Pop(sizeof(TYPE)*2) >= *(TYPE *)(stack.GetConst()+stack.GetLength()+sizeof(TYPE));
		Push(b);
	}
	template<typename TYPE> void PopToHensuu(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		HensuuAddressHenkan(ip);
		*(TYPE *)ip = Pop<TYPE>();
	}
	void PopToMemberStack()
	{
		memberstack += Pop<intptr_t>();
	}
	template<typename TYPE> void PushTeisuu(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		i++;
		Push(*(TYPE *)(bytecode.GetConst()+i));
		i += sizeof(TYPE) - 1;
	}
	template<typename TYPE> void PushStack()
	{
		Push(*(TYPE *)(stack.GetConst()+stack.GetLength()-sizeof(TYPE)));
	}
	template<typename TYPE> void PushHensuu(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		HensuuAddressHenkan(ip);
		Push(*(TYPE *)ip);
	}
	template<typename TYPE> void PushMemberHensuu(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		MemberAddressHenkan(ip);
		Push(*(TYPE *)ip);
	}
	template<typename TYPE> void PushGlobalHensuu(const PWCArray<uint8_t> & bytecode, intptr_t & i, PWCArray<int8_t> & globalres)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		GlobalAddressHenkan(ip, globalres);
		Push(*(TYPE *)ip);
	}
	template<typename TYPE> void PushStackSanshou()
	{
		intptr_t ip;
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		Push(*(TYPE *)ip);
	}
	void HensuuKaraSanshou(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip =*(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		ip += localhensuu;
		Push(ip);
	}
	void MemberKaraSanshou(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip =*(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		ip += memberstack.GetConst()[memberstack.GetLength()-1];
		Push(ip);
	}
	void GlobalKaraSanshou(const PWCArray<uint8_t> & bytecode, intptr_t & i, PWCArray<int8_t> & globalres)
	{
		intptr_t ip;
		i++;
		ip =*(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		ip += (intptr_t)globalres.GetConst() | INTPTR_MIN;
		Push(ip);
	}
	void Load(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t to, fr, size;
		int8_t * p;
		i++;
		size = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		p = stack.Pop(sizeof(intptr_t)*2);
		to = *(intptr_t *)p;
		SanshouAddressHenkan(to);
		fr = *(intptr_t *)(p+sizeof(intptr_t));
		SanshouAddressHenkan(fr);
		memcpy((void *)to, (void *)fr, size);
	}
	void LoadKaraSanshou(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t to, fr, size;
		int8_t * p;
		i++;
		size = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		p = stack.Pop(sizeof(intptr_t));
		to = *(intptr_t *)(p-sizeof(intptr_t));
		SanshouAddressHenkan(to);
		fr = *(intptr_t *)p;
		SanshouAddressHenkan(fr);
		memcpy((void *)to, (void *)fr, size);
	}
	void LoadSanshouKaraSanshousaki(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip, size;
		i++;
		size = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		stack.SetLength(stack.GetLength()-sizeof(intptr_t)+size);
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-size);
		SanshouAddressHenkan(ip);
		memcpy(stack.GetData()+stack.GetLength()-size, (void *)ip, size);
	}
	void HensuuStackKakuho(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		stack.SetLength(stack.GetLength()+ip);
		localstack += localhensuu;
		localhensuu = stack.GetLength();
	}
	void HensuuStackKaihou(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		stack.Pop(ip);
		localhensuu = *localstack.Pop(1);
	}
	void LocalPush()
	{
		localstack += localhensuu;
		localhensuu = stack.GetLength();
	}
	void MemberPush()
	{
		memberstack += localhensuu;
	}
	void MemberPushHensuu(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		memberstack += localhensuu + ip;
	}
	void MemberPushMember(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		memberstack += memberstack.GetConst()[memberstack.GetLength()-1] + ip;
	}
	void MemberPushGlobal(const PWCArray<uint8_t> & bytecode, intptr_t & i, PWCArray<int8_t> & globalres)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		memberstack += ((intptr_t)globalres.GetConst()|INTPTR_MIN) + ip;
	}
	void MemberPushStack()
	{
		memberstack += *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t));
	}
	void MemberPop()
	{
		memberstack.Pop(1);
	}
	void BblDelPush(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		i++;
		gbldellist += *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
	}
	void Jump(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		i++;
		i = *(intptr_t *)(bytecode.GetConst()+i) - 1;
	}
	void SwitchJump(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		uint8_t i8;
		i++;
		i8 = *(uint8_t *)(bytecode.GetConst()+i);
		i++;
		i8 = (*((uint8_t *)(stack.GetConst()+stack.GetLength())-1-(i8>>1)) & (0x0f<<(i8&0x01)*4)) >> (i8&0x01)*4;
		i = ((intptr_t *)(bytecode.GetConst()+i))[i8] - 1;
	}
	void TrueJump(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		i++;
		if(*(bool *)(stack.GetConst()+stack.GetLength()-sizeof(bool))){
			i = *(intptr_t *)(bytecode.GetConst()+i) - 1;
		}else{
			i += sizeof(intptr_t) - 1;
		}
	}
	void FalseJump(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		i++;
		if(!*(bool *)(stack.GetConst()+stack.GetLength()-sizeof(bool))){
			i = *(intptr_t *)(bytecode.GetConst()+i) - 1;
		}else{
			i += sizeof(intptr_t) - 1;
		}
	}
	void PopnTrueJump(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		i++;
		if(Pop<bool>()){
			i = *(intptr_t *)(bytecode.GetConst()+i) - 1;
		}else{
			i += sizeof(intptr_t) - 1;
		}
	}
	void PopnFalseJump(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		i++;
		if(!Pop<bool>()){
			i = *(intptr_t *)(bytecode.GetConst()+i) - 1;
		}else{
			i += sizeof(intptr_t) - 1;
		}
	}
	void Call(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		callstack += i + sizeof(intptr_t);
		i = ip - 1;
	}
	void StackCall(const PWCArray<uint8_t> & bytecode, intptr_t & i, PWCArray<int8_t> & globalres)
	{
		intptr_t ip;
		CallBackStruct cbs;
		ip  = *(intptr_t *)stack.Pop(sizeof(intptr_t));
		if(ip < 0){
			cbs.pvm = this;
			cbs.pbcode = &bytecode;
			cbs.pgres = &globalres;
			stack.SetLength(stack.GetLength()+sizeof(int64_t));//߂lp̈mɊm
			stack.Pop(sizeof(int64_t));//߂
			ip = ((PLUGINFUNC)(ip&INTPTR_MAX))(stack.GetData()+stack.GetLength(), stack.GetData(), CallBack, &cbs, sszrefnewfunc, sszrefdeletefunc);
			stack.Pop(ip);
		}else{
			callstack += i + 1;
			i = ip - 1;
		}
	}
	void Return(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		if(callstack.GetLength() <= 0){
			i = bytecode.GetLength() - 1;
		}else{
			i = *callstack.Pop(1) - 1;
		}
	}
	void HensuuRefSetNull(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		HensuuAddressHenkan(ip);
		((Reference *)ip)->init();
	}
	void MemberRefSetNull(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		MemberAddressHenkan(ip);
		((Reference *)ip)->init();
	}
	void GlobalRefSetNull(const PWCArray<uint8_t> & bytecode, intptr_t & i, PWCArray<int8_t> & globalres)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		GlobalAddressHenkan(ip, globalres);
		((Reference *)ip)->init();
	}
	void SanshouRefSetNull()
	{
		intptr_t ip;
		ip = *(intptr_t *)stack.Pop(sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		((Reference *)ip)->init();
	}
	void SanshouRefDelete()
	{
		intptr_t ip;
		ip = *(intptr_t *)stack.Pop(sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		if(((Reference *)ip)->null()) return;
		((Reference *)ip)->obj()->delEte();
		((Reference *)ip)->init();
	}
	void SanshouRefDownNZJump(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		i++;
		if( ((Reference *)ip)->null() || (intptr_t)((Reference *)ip)->pointer >= 0 || --((Reference *)ip)->obj()->head.refcount != 0 ){
			((Reference *)ip)->init();
			i = *(intptr_t *)(bytecode.GetConst()+i) - 1;
		}else{
			if(((Reference *)ip)->obj()->head.datasize > 0){
				i += sizeof(intptr_t) - 1;
			}else{
				((Reference *)ip)->obj()->delEte();
				((Reference *)ip)->init();
				i = *(intptr_t *)(bytecode.GetConst()+i) - 1;
			}
		}
	}
	void RefSize()
	{
		intptr_t * pip;
		pip = (intptr_t *)(stack.Pop(sizeof(Reference)-sizeof(intptr_t))-sizeof(intptr_t));
		if(((Reference *)pip)->null()){
			*pip = 0;
		}else{
			*pip = ((Reference *)pip)->obj()->head.datasize;;
		}
	}
	void RefLen()
	{
		intptr_t * pip;
		pip = (intptr_t *)(stack.Pop(sizeof(Reference)-sizeof(intptr_t))-sizeof(intptr_t));
		*pip = ((Reference *)pip)->len();
	}
	void RefPosSanshou()
	{
		intptr_t * pip;
		pip = (intptr_t *)(stack.Pop(sizeof(Reference)-sizeof(intptr_t))-sizeof(intptr_t));
		*pip = (intptr_t)((Reference *)pip)->atpos() | INTPTR_MIN;
	}
	void RefIdxSanshou()
	{
		intptr_t * pip;
		pip = (intptr_t *)(stack.Pop(sizeof(Reference))-sizeof(intptr_t));
		*pip = (intptr_t)(((Reference *)pip)->refat(*(intptr_t *)(stack.GetConst()+stack.GetLength()+sizeof(Reference)-sizeof(intptr_t)))) | INTPTR_MIN;
	}
	void ListIdxSanshou()
	{
		intptr_t * pip;
		pip = (intptr_t *)(stack.Pop(sizeof(Reference))-sizeof(intptr_t));
		*pip = (intptr_t)(((Reference *)pip)->listat(*(intptr_t *)(stack.GetConst()+stack.GetLength()+sizeof(Reference)-sizeof(intptr_t)))) | INTPTR_MIN;
	}
	void SanshouRefNew()
	{
		intptr_t ip;
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t)*2);
		SanshouAddressHenkan(ip);
		((Reference *)ip)->refnew(*(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t)));
	}
	void SanshouListNew()
	{
		intptr_t ip;
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t)*2);
		SanshouAddressHenkan(ip);
		((Reference *)ip)->listnew(*(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t)));
	}
	void SanshouListIdxNew()
	{
		int8_t * p, * p2;
		intptr_t ip, ip2, ip3;
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t)*3);
		SanshouAddressHenkan(ip);
		ip2 = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t));
		if(((Reference *)ip)->null()){
			ip3 = 0;
		}else{
			ip3 = ((Reference *)ip)->obj()->head.datasize;
		}
		p = ((Reference *)ip)->listnewat(*(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t)*2), ip2);
		p2 = ((Reference *)ip)->obj()->head.data + ip3;
		ip3 = ((Reference *)ip)->obj()->head.datasize - ip3;
		*(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t)*3) = (intptr_t)p | INTPTR_MIN;
		*(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t)*2) = (intptr_t)p2 | INTPTR_MIN;
		*(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t)) = ip3;
	}
	void SanshouRefCopyNZJump(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		Reference rfc;
		HeapObj * ph;
		intptr_t ip;
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t)-sizeof(Reference));
		SanshouAddressHenkan(ip);
		i++;
		rfc = *(Reference *)ip;
		ph = ((Reference *)ip)->copy(*(Reference *)(stack.GetConst()+stack.GetLength()-sizeof(Reference)));
		*(Reference *)(stack.GetConst()+stack.GetLength()-sizeof(Reference)) = rfc;
		if(ph == NULL || ph->head.refcount != 0){
			i = *(intptr_t *)(bytecode.GetConst()+i) - 1;
		}else{
			if(((Reference *)ip)->obj()->head.datasize > 0){
				i += sizeof(intptr_t) - 1;
			}else{
				((Reference *)ip)->obj()->delEte();
				((Reference *)ip)->init();
				i = *(intptr_t *)(bytecode.GetConst()+i) - 1;
			}
		}
	}
	void SanshouRefSRefNZJump(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		Reference rfc;
		HeapObj * ph;
		intptr_t ip;
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t)-sizeof(Reference));
		SanshouAddressHenkan(ip);
		i++;
		rfc = *(Reference *)ip;
		ph = ((Reference *)ip)->sref(*(Reference *)(stack.GetConst()+stack.GetLength()-sizeof(Reference)));
		*(Reference *)(stack.GetConst()+stack.GetLength()-sizeof(Reference)) = rfc;
		if(ph == NULL || ph->head.refcount != 0){
			i = *(intptr_t *)(bytecode.GetConst()+i) - 1;
		}else{
			if(((Reference *)ip)->obj()->head.datasize > 0){
				i += sizeof(intptr_t) - 1;
			}else{
				((Reference *)ip)->obj()->delEte();
				((Reference *)ip)->init();
				i = *(intptr_t *)(bytecode.GetConst()+i) - 1;
			}
		}
	}
	void SanshouRefWRefNZJump(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		Reference rfc;
		HeapObj * ph;
		intptr_t ip;
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()-sizeof(intptr_t)-sizeof(Reference));
		SanshouAddressHenkan(ip);
		i++;
		rfc = *(Reference *)ip;
		ph = ((Reference *)ip)->wref(*(Reference *)(stack.GetConst()+stack.GetLength()-sizeof(Reference)));
		*(Reference *)(stack.GetConst()+stack.GetLength()-sizeof(Reference)) = rfc;
		if(ph == NULL || ph->head.refcount != 0){
			i = *(intptr_t *)(bytecode.GetConst()+i) - 1;
		}else{
			if(((Reference *)ip)->obj()->head.datasize > 0){
				i += sizeof(intptr_t) - 1;
			}else{
				((Reference *)ip)->obj()->delEte();
				((Reference *)ip)->init();
				i = *(intptr_t *)(bytecode.GetConst()+i) - 1;
			}
		}
	}
	template<typename TYPE> void Append()
	{
		intptr_t ip, idx;
		ip = *(intptr_t *)stack.Pop(sizeof(intptr_t)+sizeof(TYPE));
		SanshouAddressHenkan(ip);
		idx = ((Reference *)ip)->addsize(sizeof(TYPE));
		*(TYPE *)(((Reference *)ip)->obj()->head.data+idx) = *(TYPE *)(stack.GetConst()+stack.GetLength()+sizeof(intptr_t));
	}
	template<typename TYPE> void AppendKaraSanshou()
	{
		intptr_t ip, idx;
		ip = *(intptr_t *)(stack.Pop(sizeof(TYPE))-sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		idx = ((Reference *)ip)->addsize(sizeof(TYPE));
		*(TYPE *)(((Reference *)ip)->obj()->head.data+idx) = *(TYPE *)(stack.GetConst()+stack.GetLength());
	}
	void AppendRef()
	{
		Reference * p;
		intptr_t ip, idx;
		ip = *(intptr_t *)stack.Pop(sizeof(intptr_t)+sizeof(Reference));
		SanshouAddressHenkan(ip);
		p = (Reference *)(stack.GetConst()+stack.GetLength()+sizeof(intptr_t));
		idx = ((Reference *)ip)->addsize(p->len());
		if(p->len() > 0) memcpy(((Reference *)ip)->obj()->head.data+idx, p->obj()->head.data+p->position, p->len());
	}
	void AppendKaraSanshouRef()
	{
		Reference * p;
		intptr_t ip, idx;
		ip = *(intptr_t *)(stack.Pop(sizeof(Reference))-sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		p = (Reference *)(stack.GetConst()+stack.GetLength());
		idx = ((Reference *)ip)->addsize(p->len());
		if(p->len() > 0) memcpy(((Reference *)ip)->obj()->head.data+idx, p->obj()->head.data+p->position, p->len());
	}
	void LoadAppend(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		Reference * p;
		intptr_t ip, idx, size;
		i++;
		size = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		ip = *(intptr_t *)stack.Pop(sizeof(intptr_t)*2);
		SanshouAddressHenkan(ip);
		p = (Reference *)ip;
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength()+sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		idx = p->addsize(size);
		memcpy(p->obj()->head.data+idx, (void *)ip, size);
	}
	void LoadAppendKaraSanshou(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		Reference * p;
		intptr_t ip, idx, size;
		i++;
		size = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		ip = *(intptr_t *)(stack.Pop(sizeof(intptr_t))-sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		p = (Reference *)ip;
		ip = *(intptr_t *)(stack.GetConst()+stack.GetLength());
		SanshouAddressHenkan(ip);
		idx = p->addsize(size);
		memcpy(p->obj()->head.data+idx, (void *)ip, size);
	}
	void RefUp()
	{
		((Reference *)(stack.GetConst()+stack.GetLength()-sizeof(Reference)))->countup();
	}
	void Slice()
	{
		Reference * p;
		p = (Reference *)(stack.Pop(sizeof(intptr_t)*3)-sizeof(Reference));
		p->slice(
			*(intptr_t *)(stack.GetConst()+stack.GetLength()),
			*(intptr_t *)(stack.GetConst()+stack.GetLength()+sizeof(intptr_t)),
			*(intptr_t *)(stack.GetConst()+stack.GetLength()+sizeof(intptr_t)*2));
	}
	void Lock()
	{
		((Reference *)(stack.GetConst()+stack.GetLength()-sizeof(Reference)))->lock();
	}
	void Unlock()
	{
		((Reference *)(stack.GetConst()+stack.GetLength()-sizeof(Reference)))->unlock();
	}
	void HensuuThreadSetNull(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		HensuuAddressHenkan(ip);
		((Thread *)ip)->init();
	}
	void MemberThreadSetNull(const PWCArray<uint8_t> & bytecode, intptr_t & i)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		MemberAddressHenkan(ip);
		((Thread *)ip)->init();
	}
	void GlobalThreadSetNull(const PWCArray<uint8_t> & bytecode, intptr_t & i, PWCArray<int8_t> & globalres)
	{
		intptr_t ip;
		i++;
		ip = *(intptr_t *)(bytecode.GetConst()+i);
		i += sizeof(intptr_t) - 1;
		GlobalAddressHenkan(ip, globalres);
		((Thread *)ip)->init();
	}
	void SanshouThreadSetNull()
	{
		intptr_t ip;
		ip = *(intptr_t *)stack.Pop(sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		((Thread *)ip)->init();
	}
	void SanshouThreadWait()
	{
		intptr_t ip;
		ip = *(intptr_t *)stack.Pop(sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		((Thread *)ip)->wait();
	}
	void SanshouThreadRun(const PWCArray<uint8_t> & bytecode, PWCArray<int8_t> & globalres)
	{
		ThreadStruct * pts;
		intptr_t ip;
		pts = new ThreadStruct;
		pts->cbs.pbcode = &bytecode;
		pts->cbs.pgres = &globalres;
		pts->jigoshori = *(intptr_t *)stack.Pop(sizeof(intptr_t));
		pts->calladr = *(intptr_t *)stack.Pop(sizeof(intptr_t));
		pts->hikisize = *(intptr_t *)stack.Pop(sizeof(intptr_t));
		pts->phikisuu = new int8_t[pts->hikisize];
		memcpy(pts->phikisuu, stack.Pop(pts->hikisize), pts->hikisize);
		ip = *(intptr_t *)stack.Pop(sizeof(intptr_t));
		SanshouAddressHenkan(ip);
		((Thread *)ip)->create(ThreadFunc, pts);
	}
	bool Jikkou(const PWCArray<uint8_t> & bytecode, PWCArray<int8_t> & globalres, const intptr_t calladr)
	{
		intptr_t i;
		i = calladr;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<intptr_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<intptr_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<intptr_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<intptr_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<intptr_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<intptr_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<intptr_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<intptr_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<intptr_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<intptr_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<intptr_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<intptr_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<intptr_t>(); break;
			case NOT_MEIREI: Not<intptr_t>(); break;
			case TASU_MEIREI: Tasu<intptr_t>(); break;
			case HIKU_MEIREI: Hiku<intptr_t>(); break;
			case KAKERU_MEIREI: Kakeru<intptr_t>(); break;
			case WARU_MEIREI: Waru<intptr_t>(); break;
			case AMARI_MEIREI: Amari<intptr_t>(); break;
			case AND_MEIREI: And<intptr_t>(); break;
			case XOR_MEIREI: Xor<intptr_t>(); break;
			case OR_MEIREI: Or<intptr_t>(); break;
			case LSHIFT_MEIREI: LShift<intptr_t>(); break;
			case RSHIFT_MEIREI: RShift<intptr_t>(); break;
			case INCL_MEIREI: Incl<intptr_t>(); break;
			case INCLKARASANSHOU_MEIREI: InclKaraSanshou<intptr_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<intptr_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<intptr_t>(); break;
			case DECL_MEIREI: Decl<intptr_t>(); break;
			case DECLKARASANSHOU_MEIREI: DeclKaraSanshou<intptr_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<intptr_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<intptr_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<intptr_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<intptr_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<intptr_t>(); break;
			case EQUAL_MEIREI: Equal<intptr_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<intptr_t>(); break;
			case SHOU_MEIREI: Shou<intptr_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<intptr_t>(); break;
			case DAI_MEIREI: Dai<intptr_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<intptr_t>(); break;
			case POP_MEIREI: Pop<intptr_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<intptr_t>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<intptr_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<intptr_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<intptr_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<intptr_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<intptr_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<intptr_t>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: Append<intptr_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<intptr_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
INDEXLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<int8_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<int8_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<int8_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<int8_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<int8_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<int8_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<int8_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<int8_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<int8_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<int8_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<int8_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<int8_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<int8_t>(); break;
			case NOT_MEIREI: Not<int8_t>(); break;
			case TASU_MEIREI: Tasu<int8_t>(); break;
			case HIKU_MEIREI: Hiku<int8_t>(); break;
			case KAKERU_MEIREI: Kakeru<int8_t>(); break;
			case WARU_MEIREI: Waru<int8_t>(); break;
			case AMARI_MEIREI: Amari<int8_t>(); break;
			case AND_MEIREI: And<int8_t>(); break;
			case XOR_MEIREI: Xor<int8_t>(); break;
			case OR_MEIREI: Or<int8_t>(); break;
			case LSHIFT_MEIREI: LShift<int8_t>(); break;
			case RSHIFT_MEIREI: RShift<int8_t>(); break;
			case INCL_MEIREI: Incl<int8_t>(); break;
			case INCLKARASANSHOU_MEIREI: InclKaraSanshou<int8_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<int8_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<int8_t>(); break;
			case DECL_MEIREI: Decl<int8_t>(); break;
			case DECLKARASANSHOU_MEIREI: DeclKaraSanshou<int8_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<int8_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<int8_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<int8_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<int8_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<int8_t>(); break;
			case EQUAL_MEIREI: Equal<int8_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<int8_t>(); break;
			case SHOU_MEIREI: Shou<int8_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<int8_t>(); break;
			case DAI_MEIREI: Dai<int8_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<int8_t>(); break;
			case POP_MEIREI: Pop<int8_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<int8_t>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<int8_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<int8_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<int8_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<int8_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<int8_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<int8_t>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: Append<int8_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<int8_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
BYTELOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<int16_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<int16_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<int16_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<int16_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<int16_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<int16_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<int16_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<int16_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<int16_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<int16_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<int16_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<int16_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<int16_t>(); break;
			case NOT_MEIREI: Not<int16_t>(); break;
			case TASU_MEIREI: Tasu<int16_t>(); break;
			case HIKU_MEIREI: Hiku<int16_t>(); break;
			case KAKERU_MEIREI: Kakeru<int16_t>(); break;
			case WARU_MEIREI: Waru<int16_t>(); break;
			case AMARI_MEIREI: Amari<int16_t>(); break;
			case AND_MEIREI: And<int16_t>(); break;
			case XOR_MEIREI: Xor<int16_t>(); break;
			case OR_MEIREI: Or<int16_t>(); break;
			case LSHIFT_MEIREI: LShift<int16_t>(); break;
			case RSHIFT_MEIREI: RShift<int16_t>(); break;
			case INCL_MEIREI: Incl<int16_t>(); break;
			case INCLKARASANSHOU_MEIREI: InclKaraSanshou<int16_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<int16_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<int16_t>(); break;
			case DECL_MEIREI: Decl<int16_t>(); break;
			case DECLKARASANSHOU_MEIREI: DeclKaraSanshou<int16_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<int16_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<int16_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<int16_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<int16_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<int16_t>(); break;
			case EQUAL_MEIREI: Equal<int16_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<int16_t>(); break;
			case SHOU_MEIREI: Shou<int16_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<int16_t>(); break;
			case DAI_MEIREI: Dai<int16_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<int16_t>(); break;
			case POP_MEIREI: Pop<int16_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<int16_t>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<int16_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<int16_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<int16_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<int16_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<int16_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<int16_t>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: Append<int16_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<int16_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
SHORTLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<int32_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<int32_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<int32_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<int32_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<int32_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<int32_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<int32_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<int32_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<int32_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<int32_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<int32_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<int32_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<int32_t>(); break;
			case NOT_MEIREI: Not<int32_t>(); break;
			case TASU_MEIREI: Tasu<int32_t>(); break;
			case HIKU_MEIREI: Hiku<int32_t>(); break;
			case KAKERU_MEIREI: Kakeru<int32_t>(); break;
			case WARU_MEIREI: Waru<int32_t>(); break;
			case AMARI_MEIREI: Amari<int32_t>(); break;
			case AND_MEIREI: And<int32_t>(); break;
			case XOR_MEIREI: Xor<int32_t>(); break;
			case OR_MEIREI: Or<int32_t>(); break;
			case LSHIFT_MEIREI: LShift<int32_t>(); break;
			case RSHIFT_MEIREI: RShift<int32_t>(); break;
			case INCL_MEIREI: Incl<int32_t>(); break;
			case INCLKARASANSHOU_MEIREI: InclKaraSanshou<int32_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<int32_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<int32_t>(); break;
			case DECL_MEIREI: Decl<int32_t>(); break;
			case DECLKARASANSHOU_MEIREI: DeclKaraSanshou<int32_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<int32_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<int32_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<int32_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<int32_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<int32_t>(); break;
			case EQUAL_MEIREI: Equal<int32_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<int32_t>(); break;
			case SHOU_MEIREI: Shou<int32_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<int32_t>(); break;
			case DAI_MEIREI: Dai<int32_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<int32_t>(); break;
			case POP_MEIREI: Pop<int32_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<int32_t>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<int32_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<int32_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<int32_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<int32_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<int32_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<int32_t>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: Append<int32_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<int32_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
INTLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<int64_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<int64_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<int64_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<int64_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<int64_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<int64_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<int64_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<int64_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<int64_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<int64_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<int64_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<int64_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<int64_t>(); break;
			case NOT_MEIREI: Not<int64_t>(); break;
			case TASU_MEIREI: Tasu<int64_t>(); break;
			case HIKU_MEIREI: Hiku<int64_t>(); break;
			case KAKERU_MEIREI: Kakeru<int64_t>(); break;
			case WARU_MEIREI: Waru<int64_t>(); break;
			case AMARI_MEIREI: Amari<int64_t>(); break;
			case AND_MEIREI: And<int64_t>(); break;
			case XOR_MEIREI: Xor<int64_t>(); break;
			case OR_MEIREI: Or<int64_t>(); break;
			case LSHIFT_MEIREI: LShift<int64_t>(); break;
			case RSHIFT_MEIREI: RShift<int64_t>(); break;
			case INCL_MEIREI: Incl<int64_t>(); break;
			case INCLKARASANSHOU_MEIREI: InclKaraSanshou<int64_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<int64_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<int64_t>(); break;
			case DECL_MEIREI: Decl<int64_t>(); break;
			case DECLKARASANSHOU_MEIREI: DeclKaraSanshou<int64_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<int64_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<int64_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<int64_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<int64_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<int64_t>(); break;
			case EQUAL_MEIREI: Equal<int64_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<int64_t>(); break;
			case SHOU_MEIREI: Shou<int64_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<int64_t>(); break;
			case DAI_MEIREI: Dai<int64_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<int64_t>(); break;
			case POP_MEIREI: Pop<int64_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<int64_t>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<int64_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<int64_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<int64_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<int64_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<int64_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<int64_t>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: Append<int64_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<int64_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
LONGLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<uint8_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<uint8_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<uint8_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<uint8_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<uint8_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<uint8_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<uint8_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<uint8_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<uint8_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<uint8_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<uint8_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<uint8_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<uint8_t>(); break;
			case NOT_MEIREI: Not<uint8_t>(); break;
			case TASU_MEIREI: Tasu<uint8_t>(); break;
			case HIKU_MEIREI: Hiku<uint8_t>(); break;
			case KAKERU_MEIREI: Kakeru<uint8_t>(); break;
			case WARU_MEIREI: Waru<uint8_t>(); break;
			case AMARI_MEIREI: Amari<uint8_t>(); break;
			case AND_MEIREI: And<uint8_t>(); break;
			case XOR_MEIREI: Xor<uint8_t>(); break;
			case OR_MEIREI: Or<uint8_t>(); break;
			case LSHIFT_MEIREI: LShift<uint8_t>(); break;
			case RSHIFT_MEIREI: RShift<uint8_t>(); break;
			case INCL_MEIREI: Incl<uint8_t>(); break;
			case INCLKARASANSHOU_MEIREI: InclKaraSanshou<uint8_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<uint8_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<uint8_t>(); break;
			case DECL_MEIREI: Decl<uint8_t>(); break;
			case DECLKARASANSHOU_MEIREI: DeclKaraSanshou<uint8_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<uint8_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<uint8_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<uint8_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<uint8_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<uint8_t>(); break;
			case EQUAL_MEIREI: Equal<uint8_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<uint8_t>(); break;
			case SHOU_MEIREI: Shou<uint8_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<uint8_t>(); break;
			case DAI_MEIREI: Dai<uint8_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<uint8_t>(); break;
			case POP_MEIREI: Pop<uint8_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<uint8_t>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<uint8_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<uint8_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<uint8_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<uint8_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<uint8_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<uint8_t>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: Append<uint8_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<uint8_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
UBYTELOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<uint16_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<uint16_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<uint16_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<uint16_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<uint16_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<uint16_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<uint16_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<uint16_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<uint16_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<uint16_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<uint16_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<uint16_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<uint16_t>(); break;
			case NOT_MEIREI: Not<uint16_t>(); break;
			case TASU_MEIREI: Tasu<uint16_t>(); break;
			case HIKU_MEIREI: Hiku<uint16_t>(); break;
			case KAKERU_MEIREI: Kakeru<uint16_t>(); break;
			case WARU_MEIREI: Waru<uint16_t>(); break;
			case AMARI_MEIREI: Amari<uint16_t>(); break;
			case AND_MEIREI: And<uint16_t>(); break;
			case XOR_MEIREI: Xor<uint16_t>(); break;
			case OR_MEIREI: Or<uint16_t>(); break;
			case LSHIFT_MEIREI: LShift<uint16_t>(); break;
			case RSHIFT_MEIREI: RShift<uint16_t>(); break;
			case INCL_MEIREI: Incl<uint16_t>(); break;
			case INCLKARASANSHOU_MEIREI: InclKaraSanshou<uint16_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<uint16_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<uint16_t>(); break;
			case DECL_MEIREI: Decl<uint16_t>(); break;
			case DECLKARASANSHOU_MEIREI: DeclKaraSanshou<uint16_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<uint16_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<uint16_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<uint16_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<uint16_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<uint16_t>(); break;
			case EQUAL_MEIREI: Equal<uint16_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<uint16_t>(); break;
			case SHOU_MEIREI: Shou<uint16_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<uint16_t>(); break;
			case DAI_MEIREI: Dai<uint16_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<uint16_t>(); break;
			case POP_MEIREI: Pop<uint16_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<uint16_t>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<uint16_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<uint16_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<uint16_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<uint16_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<uint16_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<uint16_t>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: Append<uint16_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<uint16_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
USHORTLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<uint32_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<uint32_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<uint32_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<uint32_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<uint32_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<uint32_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<uint32_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<uint32_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<uint32_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<uint32_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<uint32_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<uint32_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<uint32_t>(); break;
			case NOT_MEIREI: Not<uint32_t>(); break;
			case TASU_MEIREI: Tasu<uint32_t>(); break;
			case HIKU_MEIREI: Hiku<uint32_t>(); break;
			case KAKERU_MEIREI: Kakeru<uint32_t>(); break;
			case WARU_MEIREI: Waru<uint32_t>(); break;
			case AMARI_MEIREI: Amari<uint32_t>(); break;
			case AND_MEIREI: And<uint32_t>(); break;
			case XOR_MEIREI: Xor<uint32_t>(); break;
			case OR_MEIREI: Or<uint32_t>(); break;
			case LSHIFT_MEIREI: LShift<uint32_t>(); break;
			case RSHIFT_MEIREI: RShift<uint32_t>(); break;
			case INCL_MEIREI: Incl<uint32_t>(); break;
			case INCLKARASANSHOU_MEIREI: InclKaraSanshou<uint32_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<uint32_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<uint32_t>(); break;
			case DECL_MEIREI: Decl<uint32_t>(); break;
			case DECLKARASANSHOU_MEIREI: DeclKaraSanshou<uint32_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<uint32_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<uint32_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<uint32_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<uint32_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<uint32_t>(); break;
			case EQUAL_MEIREI: Equal<uint32_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<uint32_t>(); break;
			case SHOU_MEIREI: Shou<uint32_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<uint32_t>(); break;
			case DAI_MEIREI: Dai<uint32_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<uint32_t>(); break;
			case POP_MEIREI: Pop<uint32_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<uint32_t>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<uint32_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<uint32_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<uint32_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<uint32_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<uint32_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<uint32_t>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: Append<uint32_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<uint32_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
UINTLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<uint64_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<uint64_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<uint64_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<uint64_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<uint64_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<uint64_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<uint64_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<uint64_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<uint64_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<uint64_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<uint64_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<uint64_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<uint64_t>(); break;
			case NOT_MEIREI: Not<uint64_t>(); break;
			case TASU_MEIREI: Tasu<uint64_t>(); break;
			case HIKU_MEIREI: Hiku<uint64_t>(); break;
			case KAKERU_MEIREI: Kakeru<uint64_t>(); break;
			case WARU_MEIREI: Waru<uint64_t>(); break;
			case AMARI_MEIREI: Amari<uint64_t>(); break;
			case AND_MEIREI: And<uint64_t>(); break;
			case XOR_MEIREI: Xor<uint64_t>(); break;
			case OR_MEIREI: Or<uint64_t>(); break;
			case LSHIFT_MEIREI: LShift<uint64_t>(); break;
			case RSHIFT_MEIREI: RShift<uint64_t>(); break;
			case INCL_MEIREI: Incl<uint64_t>(); break;
			case INCLKARASANSHOU_MEIREI: InclKaraSanshou<uint64_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<uint64_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<uint64_t>(); break;
			case DECL_MEIREI: Decl<uint64_t>(); break;
			case DECLKARASANSHOU_MEIREI: DeclKaraSanshou<uint64_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<uint64_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<uint64_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<uint64_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<uint64_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<uint64_t>(); break;
			case EQUAL_MEIREI: Equal<uint64_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<uint64_t>(); break;
			case SHOU_MEIREI: Shou<uint64_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<uint64_t>(); break;
			case DAI_MEIREI: Dai<uint64_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<uint64_t>(); break;
			case POP_MEIREI: Pop<uint64_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<uint64_t>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<uint64_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<uint64_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<uint64_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<uint64_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<uint64_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<uint64_t>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: Append<uint64_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<uint64_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
ULONGLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<wchar_t, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<wchar_t, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<wchar_t, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<wchar_t, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<wchar_t, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<wchar_t, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<wchar_t, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<wchar_t, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<wchar_t, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<wchar_t, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<wchar_t, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<wchar_t, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<wchar_t>(); break;
			case NOT_MEIREI: Not<wchar_t>(); break;
			case TASU_MEIREI: Tasu<wchar_t>(); break;
			case HIKU_MEIREI: Hiku<wchar_t>(); break;
			case KAKERU_MEIREI: Kakeru<wchar_t>(); break;
			case WARU_MEIREI: Waru<wchar_t>(); break;
			case AMARI_MEIREI: Amari<wchar_t>(); break;
			case AND_MEIREI: And<wchar_t>(); break;
			case XOR_MEIREI: Xor<wchar_t>(); break;
			case OR_MEIREI: Or<wchar_t>(); break;
			case LSHIFT_MEIREI: LShift<wchar_t>(); break;
			case RSHIFT_MEIREI: RShift<wchar_t>(); break;
			case INCL_MEIREI: Incl<wchar_t>(); break;
			case INCLKARASANSHOU_MEIREI: InclKaraSanshou<wchar_t>(); break;
			case INCLKARAATAI_MEIREI: InclKaraAtai<wchar_t>(); break;
			case INCLKARAMAENOATAI_MEIREI: InclKaraMaenoAtai<wchar_t>(); break;
			case DECL_MEIREI: Decl<wchar_t>(); break;
			case DECLKARASANSHOU_MEIREI: DeclKaraSanshou<wchar_t>(); break;
			case DECLKARAATAI_MEIREI: DeclKaraAtai<wchar_t>(); break;
			case DECLKARAMAENOATAI_MEIREI: DeclKaraMaenoAtai<wchar_t>(); break;
			case DAINYUU_MEIREI: Dainyuu<wchar_t>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<wchar_t>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<wchar_t>(); break;
			case EQUAL_MEIREI: Equal<wchar_t>(); break;
			case NOTEQUAL_MEIREI: NotEqual<wchar_t>(); break;
			case SHOU_MEIREI: Shou<wchar_t>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<wchar_t>(); break;
			case DAI_MEIREI: Dai<wchar_t>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<wchar_t>(); break;
			case POP_MEIREI: Pop<wchar_t>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<wchar_t>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<wchar_t>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<wchar_t>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<wchar_t>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<wchar_t>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<wchar_t>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<wchar_t>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: Append<wchar_t>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<wchar_t>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
CHARLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<float, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<float, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<float, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<float, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<float, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<float, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<float, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<float, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<float, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<float, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<float, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<float, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<float>(); break;
			case TASU_MEIREI: Tasu<float>(); break;
			case HIKU_MEIREI: Hiku<float>(); break;
			case KAKERU_MEIREI: Kakeru<float>(); break;
			case WARU_MEIREI: Waru<float>(); break;
			case DAINYUU_MEIREI: Dainyuu<float>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<float>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<float>(); break;
			case EQUAL_MEIREI: Equal<float>(); break;
			case NOTEQUAL_MEIREI: NotEqual<float>(); break;
			case SHOU_MEIREI: Shou<float>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<float>(); break;
			case DAI_MEIREI: Dai<float>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<float>(); break;
			case POP_MEIREI: Pop<float>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<float>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<float>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<float>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<float>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<float>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<float>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<float>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: Append<float>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<float>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
FLOATLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<double, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<double, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<double, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<double, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<double, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<double, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<double, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<double, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<double, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<double, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<double, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<double, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case MINUS_MEIREI: Minus<double>(); break;
			case TASU_MEIREI: Tasu<double>(); break;
			case HIKU_MEIREI: Hiku<double>(); break;
			case KAKERU_MEIREI: Kakeru<double>(); break;
			case WARU_MEIREI: Waru<double>(); break;
			case DAINYUU_MEIREI: Dainyuu<double>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<double>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<double>(); break;
			case EQUAL_MEIREI: Equal<double>(); break;
			case NOTEQUAL_MEIREI: NotEqual<double>(); break;
			case SHOU_MEIREI: Shou<double>(); break;
			case SHOUOREQUAL_MEIREI: ShouorEqual<double>(); break;
			case DAI_MEIREI: Dai<double>(); break;
			case DAIOREQUAL_MEIREI: DaiorEqual<double>(); break;
			case POP_MEIREI: Pop<double>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<double>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<double>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<double>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<double>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<double>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<double>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<double>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: Append<double>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<double>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
DOUBLELOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case CASTBYTETYPE_MEIREI: Cast<bool, int8_t>(); goto BYTELOOPEND;
			case CASTSHORTTYPE_MEIREI: Cast<bool, int16_t>(); goto SHORTLOOPEND;
			case CASTINTTYPE_MEIREI: Cast<bool, int32_t>(); goto INTLOOPEND;
			case CASTLONGTYPE_MEIREI: Cast<bool, int64_t>(); goto LONGLOOPEND;
			case CASTUBYTETYPE_MEIREI: Cast<bool, uint8_t>(); goto UBYTELOOPEND;
			case CASTUSHORTTYPE_MEIREI: Cast<bool, uint16_t>(); goto USHORTLOOPEND;
			case CASTUINTTYPE_MEIREI: Cast<bool, uint32_t>(); goto UINTLOOPEND;
			case CASTULONGTYPE_MEIREI: Cast<bool, uint64_t>(); goto ULONGLOOPEND;
			case CASTINDEXTYPE_MEIREI: Cast<bool, intptr_t>(); goto INDEXLOOPEND;
			case CASTCHARTYPE_MEIREI: Cast<bool, wchar_t>(); goto CHARLOOPEND;
			case CASTFLOATTYPE_MEIREI: Cast<bool, float>(); goto FLOATLOOPEND;
			case CASTDOUBLETYPE_MEIREI: Cast<bool, double>(); goto DOUBLELOOPEND;
			case NOP_MEIREI: break;
			case NOT_MEIREI: NotBool(); break;
			case AND_MEIREI: AndBool(); break;
			case XOR_MEIREI: XorBool(); break;
			case OR_MEIREI: OrBool(); break;
			case DAINYUU_MEIREI: Dainyuu<bool>(); break;
			case DAINYUUKARASANSHOU_MEIREI: DainyuuKaraSanshou<bool>(); break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<bool>(); break;
			case EQUAL_MEIREI: Equal<bool>(); break;
			case NOTEQUAL_MEIREI: NotEqual<bool>(); break;
			case POP_MEIREI: Pop<bool>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<bool>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<bool>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<bool>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<bool>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<bool>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<bool>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<bool>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: Append<bool>(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshou<bool>(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
BOOLLOOPEND:;
		}
		return true;
		for(; i < bytecode.GetLength(); i++){
			switch(bytecode.GetConst()[i]){
			case BYTETYPE_MEIREI: goto BYTELOOPEND;
			case SHORTTYPE_MEIREI: goto SHORTLOOPEND;
			case INTTYPE_MEIREI: goto INTLOOPEND;
			case LONGTYPE_MEIREI: goto LONGLOOPEND;
			case UBYTETYPE_MEIREI: goto UBYTELOOPEND;
			case USHORTTYPE_MEIREI: goto USHORTLOOPEND;
			case UINTTYPE_MEIREI: goto UINTLOOPEND;
			case ULONGTYPE_MEIREI: goto ULONGLOOPEND;
			case INDEXTYPE_MEIREI: goto INDEXLOOPEND;
			case CHARTYPE_MEIREI: goto CHARLOOPEND;
			case FLOATTYPE_MEIREI: goto FLOATLOOPEND;
			case DOUBLETYPE_MEIREI: goto DOUBLELOOPEND;
			case BOOLTYPE_MEIREI: goto BOOLLOOPEND;
			case REFTYPE_MEIREI: goto REFLOOPEND;
			case NOP_MEIREI: break;
			case SANSHOUKARASANSHOUSAKI_MEIREI: SanshouKaraSanshousaki<Reference>(); break;
			case EQUAL_MEIREI: EqualRef(); break;
			case NOTEQUAL_MEIREI: NotEqualRef(); break;
			case POP_MEIREI: Pop<Reference>(); break;
			case POPADDRESS_MEIREI: Pop<intptr_t>(); break;
			case POPTOHENSUU_MEIREI: PopToHensuu<Reference>(bytecode, i); break;
			case POPTOMEMBERSTACK_MEIREI: PopToMemberStack(); break;
			case PUSHTEISUU_MEIREI: PushTeisuu<Reference>(bytecode, i); break;
			case PUSHSTACK_MEIREI: PushStack<Reference>(); break;
			case PUSHHENSUU_MEIREI: PushHensuu<Reference>(bytecode, i); break;
			case PUSHMEMBERHENSUU_MEIREI: PushMemberHensuu<Reference>(bytecode, i); break;
			case PUSHGLOBALHENSUU_MEIREI: PushGlobalHensuu<Reference>(bytecode, i, globalres); break;
			case PUSHSTACKSANSHOU_MEIREI: PushStackSanshou<Reference>(); break;
			case HENSUUKARASANSHOU_MEIREI: HensuuKaraSanshou(bytecode, i); break;
			case MEMBERKARASANSHOU_MEIREI: MemberKaraSanshou(bytecode, i); break;
			case GLOBALKARASANSHOU_MEIREI: GlobalKaraSanshou(bytecode, i, globalres); break;
			case LOAD_MEIREI: Load(bytecode, i); break;
			case LOADKARASANSHOU_MEIREI: LoadKaraSanshou(bytecode, i); break;
			case LOADSANSHOUKARASANSHOUSAKI_MEIREI: LoadSanshouKaraSanshousaki(bytecode, i); break;
			case HENSUUSTACKKAKUHO_MEIREI: HensuuStackKakuho(bytecode, i); break;
			case HENSUUSTACKKAIHOU_MEIREI: HensuuStackKaihou(bytecode, i); break;
			case LOCALPUSH_MEIREI: LocalPush(); break;
			case MEMBERPUSH_MEIREI: MemberPush(); break;
			case MEMBERPUSHHENSUU_MEIREI: MemberPushHensuu(bytecode, i); break;
			case MEMBERPUSHMEMBER_MEIREI: MemberPushMember(bytecode, i); break;
			case MEMBERPUSHGLOBAL_MEIREI: MemberPushGlobal(bytecode, i, globalres); break;
			case MEMBERPUSHSTACK_MEIREI: MemberPushStack(); break;
			case MEMBERPOP_MEIREI: MemberPop(); break;
			case GBLDELPUSH_MEIREI: BblDelPush(bytecode, i); break;
			case JUMP_MEIREI: Jump(bytecode, i); break;
			case SWITCHJUMP_MEIREI: SwitchJump(bytecode, i); break;
			case TRUEJUMP_MEIREI: TrueJump(bytecode, i); break;
			case FALSEJUMP_MEIREI: FalseJump(bytecode, i); break;
			case POPNTRUEJUMP_MEIREI: PopnTrueJump(bytecode, i); break;
			case POPNFALSEJUMP_MEIREI: PopnFalseJump(bytecode, i); break;
			case CALL_MEIREI: Call(bytecode, i); break;
			case STACKCALL_MEIREI: StackCall(bytecode, i, globalres); break;
			case RETURN_MEIREI: Return(bytecode, i); break;
			case HENSUUREFSETNULL_MEIREI: HensuuRefSetNull(bytecode, i); break;
			case MEMBERREFSETNULL_MEIREI: MemberRefSetNull(bytecode, i); break;
			case GLOBALREFSETNULL_MEIREI: GlobalRefSetNull(bytecode, i, globalres); break;
			case SANSHOUREFSETNULL_MEIREI: SanshouRefSetNull(); break;
			case SANSHOUREFDELETE_MEIREI: SanshouRefDelete(); break;
			case SANSHOUREFDOWNNZJUMP_MEIREI: SanshouRefDownNZJump(bytecode, i); break;
			case SANSHOUREFNEW_MEIREI: SanshouRefNew(); break;
			case SANSHOULISTNEW_MEIREI: SanshouListNew(); break;
			case SANSHOULISTIDXNEW_MEIREI: SanshouListIdxNew(); break;
			case SANSHOUREFCOPYNZJUMP_MEIREI: SanshouRefCopyNZJump(bytecode, i); break;
			case SANSHOUREFSREFNZJUMP_MEIREI: SanshouRefSRefNZJump(bytecode, i); break;
			case SANSHOUREFWREFNZJUMP_MEIREI: SanshouRefWRefNZJump(bytecode, i); break;
			case REFSIZE_MEIREI: RefSize(); break;
			case REFLEN_MEIREI: RefLen(); break;
			case REFPOSSANSHOU_MEIREI: RefPosSanshou(); break;
			case REFIDXSANSHOU_MEIREI: RefIdxSanshou(); break;
			case LISTIDXSANSHOU_MEIREI: ListIdxSanshou(); break;
			case APPEND_MEIREI: AppendRef(); break;
			case APPENDKARASANSHOU_MEIREI: AppendKaraSanshouRef(); break;
			case LOADAPPEND_MEIREI: LoadAppend(bytecode, i); break;
			case LOADAPPENDKARASANSHOU_MEIREI: LoadAppendKaraSanshou(bytecode, i); break;
			case REFUP_MEIREI: RefUp(); break;
			case SLICE_MEIREI: Slice(); break;
			case LOCK_MEIREI: Lock(); break;
			case UNLOCK_MEIREI: Unlock(); break;
			case HENSUUTHREADSETNULL_MEIREI: HensuuThreadSetNull(bytecode, i); break;
			case MEMBERTHREADSETNULL_MEIREI: MemberThreadSetNull(bytecode, i); break;
			case GLOBALTHREADSETNULL_MEIREI: GlobalThreadSetNull(bytecode, i, globalres); break;
			case SANSHOUTHREADSETNULL_MEIREI: SanshouThreadSetNull(); break;
			case SANSHOUTHREADWAIT_MEIREI: SanshouThreadWait(); break;
			case SANSHOUTHREADRUN_MEIREI: SanshouThreadRun(bytecode, globalres); break;
			default: return false;
			}
REFLOOPEND:;
		}
		return true;
	}
	bool Run(const PWCArray<uint8_t> & bytecode, PWCArray<int8_t> & globalres)
	{
		int i;
		if(!Jikkou(bytecode, globalres, 0)) return false;
		for(i = gbldellist.GetLength()-1; i >= 0; i--){
			if(!Jikkou(bytecode, globalres, gbldellist.GetConst()[i])) return false;
		}
		gbldellist.Clear();
		return true;
	}
};
